#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;

class Employee {
    string name;
    string mobileNumber;
    char maritalstatus;
    int hoursworked;
    double hourlyrate;
public:

    Employee(string name, string mobileNumber, char maritalstatus, int hoursworked, double hourlyrate);
    
    double GetNetPay();
    
    void PrintReport();
};

Employee::Employee(string name, string mobileNumber, char maritalstatus, int hoursworked, double hourlyrate)
{
    this->name = name;
    this->mobileNumber = mobileNumber;
    this->maritalstatus = maritalstatus;
    this->hoursworked = hoursworked;
    this->hourlyrate = hourlyrate;
}

double Employee::GetNetPay()
{
    return this->hoursworked * this->hourlyrate;
}

void Employee::PrintReport()
{
    cout << setprecision(2)<< setiosflags(ios::fixed | ios::showpoint);
    
 	cout << setw(10) << this->name << setw(15) << this->mobileNumber <<setw(15) << this->maritalstatus
 	<< setw(15) << this->hoursworked << setw(15) << this->hourlyrate << setw(15) << GetNetPay() << endl;
}

void PrintHeadings() {	
 	cout << setw(45) << "-PAYROLL REPORT-"<<endl;
	cout << "----------------------------------------------------------------------------------------------" << endl; 
	cout << setw(10) << "Name" << setw(15) << "MobileNumber" <<setw(15) << "MaritalStatus"
 	<< setw(15) << "Hours Worked" << setw(15) << "HourlyRate" << setw(15) << "NetPay" << endl;
    cout << "----------------------------------------------------------------------------------------------" << endl; 
}//PrintHeadings

void PrintCompanyReport()
{
    string employeename, mobileNumber;
    char maritalstatus;
    int hoursworked, employeeCount = 0;
    double hourlyrate, averageNetPay = 0;
    
    ifstream fin;
    
    fin.open("payroll.dat");
    
    PrintHeadings();
    
    while( fin >> employeename >> mobileNumber >> maritalstatus >> hoursworked >> hourlyrate) {
        
        Employee emp(employeename, mobileNumber, maritalstatus, hoursworked, hourlyrate);
        emp.PrintReport();
        
        averageNetPay += emp.GetNetPay();
        
        employeeCount++;
	}
	
	cout << "----------------------------------------------------------------------------------------------" << endl; 
	
	cout << "Average NetPay : " << (averageNetPay / employeeCount) << endl; 
}

int main()
{
    PrintCompanyReport();

    return 0;
}